<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RentacarContract ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RentacarContract extends AbstractStructArrayBase
{
    /**
     * The RentacarContract
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RentacarContract[]
     */
    public $RentacarContract;
    /**
     * Constructor method for ArrayOfJP_RentacarContract
     * @uses ArrayOfJP_RentacarContract::setRentacarContract()
     * @param \StructType\JP_RentacarContract[] $rentacarContract
     */
    public function __construct(array $rentacarContract = array())
    {
        $this
            ->setRentacarContract($rentacarContract);
    }
    /**
     * Get RentacarContract value
     * @return \StructType\JP_RentacarContract[]|null
     */
    public function getRentacarContract()
    {
        return $this->RentacarContract;
    }
    /**
     * Set RentacarContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarContract[] $rentacarContract
     * @return \ArrayType\ArrayOfJP_RentacarContract
     */
    public function setRentacarContract(array $rentacarContract = array())
    {
        foreach ($rentacarContract as $arrayOfJP_RentacarContractRentacarContractItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RentacarContractRentacarContractItem instanceof \StructType\JP_RentacarContract) {
                throw new \InvalidArgumentException(sprintf('The RentacarContract property can only contain items of \StructType\JP_RentacarContract, "%s" given', is_object($arrayOfJP_RentacarContractRentacarContractItem) ? get_class($arrayOfJP_RentacarContractRentacarContractItem) : gettype($arrayOfJP_RentacarContractRentacarContractItem)), __LINE__);
            }
        }
        $this->RentacarContract = $rentacarContract;
        return $this;
    }
    /**
     * Add item to RentacarContract value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RentacarContract $item
     * @return \ArrayType\ArrayOfJP_RentacarContract
     */
    public function addToRentacarContract(\StructType\JP_RentacarContract $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RentacarContract) {
            throw new \InvalidArgumentException(sprintf('The RentacarContract property can only contain items of \StructType\JP_RentacarContract, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->RentacarContract[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RentacarContract|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RentacarContract|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RentacarContract|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RentacarContract|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RentacarContract|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RentacarContract
     */
    public function getAttributeName()
    {
        return 'RentacarContract';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RentacarContract
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
